// Anforderung eines Helis zum Transport an einen Zielort, welcher ber
//  einen Klick auf die Karte bestimmt wird. [Vienna 20.08.2008]
//
// Aufrufbeispiel ber Aktionsmen: player addAction ["*** Helitransport anfordern ***", "myHeli\myHeli.sqf",[],-1,false,true,""];
//
// Verwendet Skripts: "myHeliInfo.sqf" und "myHeliWaypoints.sqf"

// lokale Variable
	private ["_clearAllWP","_addWP","_info","_t","_l","_h","_p","_wp","_s","_i"];


//Funktion alle Wegpunkgte lschen. Aufurf: <Objekt> call _clearAllWP
	_clearAllWP = compile "private['_w'];for[{_w=Count Waypoints _this},{_w>=0},{_w=_w-1}]do{deleteWaypoint[group _this,_w]}";

//Funktion Wegpunkt hinzufgen. Aufruf: [<Objekt>,[<Position>],"Type"] call _addWP
	_addWP = compile "Private['_w'];_w=group(_this select 0)AddWaypoint[_this select 1,Count Waypoints (_this select 0)];_w SetWaypointType (_this select 2);_w ShowWaypoint'always';_w";

//globale Variable beim ersten Aufruf fr Bestimmung ob ein Heli aktiv ist.
	if (isNil "myHeliAktiv") then {myHeliAktiv = false};
	
//globale Variable Zielposition
	myHeliZielPosition = position player;

//Skript beenden falls bereits ein Heli akiv ist
	if(myHeliAktiv) exitWith {player groupChat "Not possible for order at this time!"};

// globale Variable 
	myHeliAktiv = true;  // verhindert doppelte Anforderung des Helis

// _info: Textausgaben fr dieses Skript
	_info = [" -----> -----> -----> "];
	_info = _info + ["Helicopters comes!"];
	_info = _info + ["Fly to the destination!"];
	_info = _info + ["J U M P  D O W N !"];
	_info = _info + ["New helicopters ready!"];
// _t: "Not-Ausstieg" nach ca. 3 Minuten "Leerlauf"
	_t = time + 180;
// _l: unsichtbares Lande H
	_l = "HeliHEmpty" createVehicleLocal myHeliZielPosition;
// _h: Heli
	_h = createVehicle ["MH6_RACS", myHeliZielPosition, [], 1000, "FLY"];
// _p: Pilot
	if (playerSide == WEST)
		then {_p = createGroup WEST createUnit ["SoldierWPilot", position _h, [], 0, "NONE"]}
		else {_p = createGroup EAST createUnit ["SoldierEPilot", position _h, [], 0, "NONE"]};
	_p setBehaviour "careless";
	_p setCombatMode "BLUE";
	_p allowFleeing 0;
	_p moveInDriver _h;

// Pilot fliegt zu Spieler
	player groupChat format["%1%2",_info select 0,_info select 1];
	_h flyinHeight 40;
	sleep 0.01;
	
//Skript fr Anzeige des Helistatus laden. 1.Aufruf
	[1,_h,_p] execVM "myHeli\myHeliInfo.sqf";

// _wp: fr Wegpunkthandhabung des Piloten
	_wp = group _p addWaypoint [myHeliZielPosition,0];
	[group _p, 0] SetWaypointType "move";
	group _p setCurrentWaypoint [group _p, 1];
	sleep 3;
	_h setspeedMode "full";

// Warten bis Pilot beim Spieler eintrifft
	waitUntil {_h distance myHeliZielPosition < 150 OR time > _t};
	_h flyinHeight 15;
	_h land "GET IN";
	waitUntil {speed _h < 10 OR time > _t};
	_h flyinHeight 3;

// Warten bis Spieler im Heli
	waitUntil {player in _h OR time > _t OR !(alive _p and _p IN _h)};
	if (time < _t and _p IN _h and alive _p) then 
		{
			// Warten bis Zielposition auf der Karte eingezeichnet
			ViennaMyHeliWP = 0;      // Fr Wegpunkte auf Karte setzen. 4 = Abflug
			myHeliZielPosition = []; // Beendet den 1. Aufruf von myHeliInfo.sqf
			3 execVM "myHeli\myHeliWaypoints.sqf";  // Karte zum Eintragen der Wegpunkte aufrufen
			sleep 1;
			waitUntil {ViennaMyHeliWP == 4 OR time > _t OR !dialog}; // Warten bis Zielort eingetragen
			// Kartenklick, Karte und Lande-H lschen
			onMapSingleClick "";
			closeDialog 0;
			deleteVehicle _l;
			// Zielort anfliegen
			if (time < _t and ViennaMyHeliWP == 4) then //Abflug zum Zielort
				{
					player groupChat format["%1%2",_info select 0,_info select 2];
					//Pilot Heli hochziehen
					_h doMove getPos _h;
					_h flyinHeight 80;
					Sleep 2;
					//Wegpunkte vom Spieler (ohne Wegpunkt 0) auf den Piloten bertragen
					_p call _clearAllWP;
					for [{_i=0},{Count Waypoints player > _i+1},{_i=_i+1}] do {[_p,waypointPosition[group player, _i+1],"MOVE"] call _addWP};
					player call _clearAllWP;
					//Neues Ziel in Publikvariable
					myHeliZielPosition = waypointPosition[group _p,(Count Waypoints _p)-1];
					//Skript fr Anzeige des Helistatus laden. 2. Aufruf
					[2,_h,_p] execVM "myHeli\myHeliInfo.sqf";
					// Warten bis Heli am Ziel eingetroffen
					while {_h distance myHeliZielPosition > 200 AND time < _t} do
						{
							_t=_t+5;//verlngern der "Not-Ausstiegzeit"
							sleep 5
						}; 
					player groupChat format["%1%2",_info select 0,_info select 3]
				}
			else // Alle raus, Heli fliegt allein ins Abseits ab
				{
					{_x action["Eject",_h]} forEach units group player
				}
		};
	
//_s: Warten bis nchste Helianforderung mglich
	if (count crew _h > 1) then {_s = 100} else {_s = 40};
	if (_t-time < _s) then {_s = _t-time};
	if (_s < 1) then {_s = 1};

//Pilot im Heli?
	if (_p IN _h  and alive _p) then 
		{
			// Wenn wenn nur noch Pilot im Heli oder "Not-Ausstiegzeit" abgelaufen, dann Wegflug des Helis
			waitUntil {(count crew _h < 2) OR time > _t};
			//Pilot neuer Wegpunkt
			_wp = group _p addWaypoint [[0,0],Count Waypoints _p];
			[group _p, (Count Waypoints _p)-1] SetWaypointType "move";
			group _p setCurrentWaypoint [group _p,Count Waypoints _p];
			_h flyinHeight 100
		}
	else
		{
			//Wenn Pilot nicht im Heli, dann Heli flugunfhig setzen
			_h setDamage 0.8;
			if (_s > 31) then {_s = _s - 30};
			sleep 30
		};

// sind nach Zeitablauf noch mehr als der Pilot im Heli oder ist der Pilot tot oder nicht im Heli, dann wird der Heli jetzt zerstrt.
	if ((count crew _h > 1 AND time > _t) OR not alive _p OR not(_p IN _h)) then {_h setDamage 0.95; sleep _s; _s=1};

//Pilot alle Wegpunkte lschen; Piloten, Heli und Lande H entfernen 
	sleep 20;
	if (count crew _h == 0 AND time < _t AND _S > 1) then {sleep _s; _s=1};
	_p call _clearAllWP;
	deleteVehicle _h;
	deleteVehicle _p;
	deleteVehicle _l;

// neue Helianforderung mglich	
	sleep _s;
	if(myHeliAktiv) then {myHeliAktiv = false; player groupChat format["%1%2",_info select 0,_info select 4]}
